# Readme

## Allgemein
Der KeyWarrior100 wird ohne programmierte Tastaturtabellen (leer) ausgeliefert. Für die Programmierung stellen wir einige Programme zur Verfügung um den KeyWarrior100 zu programmieren und alle anderen Einstellungen vornehmen zu können.  

Der KeyWarrior100 kann nur mit der gültigen PIN programmiert oder ausgelesen werden. Die PIN ist Werksseitig *'FFFFFFFFFFFFFFFF'* (16xF), kann aber mit dem ***KW100 Editor*** geändert werden. Die PIN dient zur absicherung der Einstellungen vor unautorisiertem Zugriff auf den internen Speicher. Sollte eine falsche PIN genutzt werden, geht der KeyWarrior100 in einen "Fehlerzustand" und es können nur noch die Geräteinformationen gelesen werden (Seriennummer, Version, etc.). Erst nach einem kompletten neuanschluss des KeyWarrior100 ist dieser wieder im normalen Betriebsmodus.

## KW100 Editor
Der ***KW100 Editor*** ist ein Programm zum erstellen und übertragen der Tastaturtabelle und aller anderer Einstellungen für den KeyWarrior100. Mit diesem Programm können auch die Einstellungen in einer *.kw100 Datei gespeichert oder ausgelesen werden.


## KW100 CLI
Die ***KW100_CLI*** ist eine Software zum programmieren einer .kw100 Datei, 
die mittels ***KW100 Editor*** erstellt wurde. Mit diesem Programm kann man über eine Kommandozeile (z.B. mit einem Terminal Programm oder Konsole) die gewünschten Daten in einen KeyWarrior100 schreiben. 

### Optionen
Als Argumente / Optionen stehen folgende zur Verfügung:

- -h : Optionen anzeigen  
- -v : Verbose / Textausgabe in der Konsole  
- -i : Zeigt die Geräteinformationen (Seriennummer, Version)
- -c : Löschen des Speichers
- -p [pin] : PIN
- -f [file] : .kw100 Datei
- -l [file] : Schreiben in eine Log-Datei

Für die Optionen **-f** und **-l** müssen immer komplette Dateipfade angegeben werden (z.B. c:\temp\<dateiname>).  
Für die Optionen **-c** und **-f** kann eine Ausgabe in der Konsole  werden mit der Option **-v** angezeigt werden. Ohne diese Option wird keinerlei Ausgabe (Außer Fehlermeldung) angezeigt. Ebenfalls benötigt man für diese Optionen immer eine PIN (**-p**).  

Die Software unterstütz ein einfaches logging. Hier werden in einer angegebenen
Datei bei einer erfolgreichen Programmierung das Datum, die Seriennummer, die
Firmwareversion und die benutzte .kw100 Datei geschrieben. Programmiervorgänge, die fehlerhaft wahren oder Fehlermeldung werden nicht gespeichert. Dieses Logging dient zur nachvollziehbarkeit was wo und wann programmiert wurde, bzw. der KeyWarrior100 gelöscht wurde. Die Nutzung der Option ***-l*** ist optinal und muss nicht benutzt werden.

Wenn ein KeyWarrior100 über diese Software programmiert wird, wird dieser automatisch vor der Programmierung gelöscht. Die Option ***-c*** wird für die Programmierung nicht benötigt.


### Fehlercodes / Returnvalues
Folgende Fehlercode (INT) werden zurückgeliefert und können extern ausgewertet werden:

- 0 = Success
- 1 = No KW100
- 2 = Too many KW100
- 4 = Read/Write error
- 8 = Key table file not found
- 16 = Argument error
- 32 = Cancel programm
- 64 = PIN error
- 128 = Read/Write timeout
- 256 = File content error

Um den Rückgabewert aus der Kommandozeile zu erhalten kann hierfür den Windowsbefehl 
```
'%errorlevel%'
```
verwenden. In der Windows PowerShell kann diese über 
```
'Write-Host "Exit-Code: $LASTEXITCODE"' erreicht werden.
``` 


### Beispiele der Nutzung
**! Alle Kommandos werden ohne vorherige Sicherheitsabfrage ausgeführt !**

Anzeigen der Informationen in der Konsole

```
kw100_cli.exe -i
```
Löschen des Speichers`
```
kw100_cli.exe -c -p ffffffffffffffff
```  
Schreiben einer .kw100 Datei inkl Logging und Textausgabe (Die Pfade dienen als Beispiel)
```
kw100_cli.exe -f "c:\test\demo.kw100" -p ffffffffffffffff -l "c:\test\test.log"
```
